﻿var adv_search;
var langs;
var search_engines = {};
var lingvo_tune;
var lingvo_lang = 'en';
var is_lingvo = false;
var UNDEF = 'undefined';
var cookie_lingvo_pref = 'LingvoPref';
var cookie_lingvo_dicts = 'LINGVODICTS';
var cookie_encyc_dicts = 'ENCYCDICTS';
var cookie_timeout = 10 * 365 * 24; // in hours
var checked_translate = false;
var typing_start = false;
var agt = navigator.userAgent.toLowerCase();

// Cookie functions
function setCookie(name, value, time)
{
    if (value != null && value != '') {
        var kukki = name + '=' + escape(value) + ';path=/;domain=.yandex.ru';
        if (typeof(time) != UNDEF) {
            var expire = new Date();
            expire.setTime((new Date()).getTime() + time * 3600000);
            kukki += ';expires=' + expire.toGMTString();
        }
        document.cookie = kukki;
    }
    return true;
}

function setCookieNew(val, num)
{
    var name_param;
    var value = "";
    var is_set = false;
    if(val == null) return false;
    switch (num) {
        case 30:
            is_set = true;
            name_param = "kbd";
            break
        case 31:
            is_set = 'settings';
            name_param = "settings";
            break
        case 32:
            name_param = "advanced";
            break
        case 35:
            is_set = true;
            name_param = "switcher";
            break
    }
    if (is_set) {
        for (var i in val) {
            value += 'param' + i + '=' + val[i] + '&';
        }
        var src = '/set_cookie_' + name_param + '.xml?' + value + 'retpath=null.xml&rand=' + Math.random();

        if(is_set == 'settings') {
            document.location.href = src + '&retpath=/tune.xml'
        } else {
            var obj = new Image();
            /*alert("src=" + src);*/
            obj.src = src;
        }
    }
    return true;
}

function getCookie(name)
{
    var kukki = document.cookie;
    var index = kukki.indexOf(name + '=');
    if (index == -1) {
        return null;
    }
    index = kukki.indexOf('=', index) + 1;
    var endstr = kukki.indexOf(';', index);
    if (endstr == -1) {
        endstr = kukki.length;
    }
    return unescape(kukki.substring(index, endstr));
}

function delCookie(name)
{
    var today = new Date();
    var expire = new Date();
    expire.setTime(today.getTime() - 3600000 * 24 * 365);
    document.cookie = name + '=' + 'value=;expires=' + expire.toGMTString() + ';path=/;domain=.yandex.ru';
}
// End of Cookie functions

function contains(object, element)
{
    for (var i in object) {
        if (object[i] == element) {
            return true;
        }
    }
    return false;
}

function getFormRadioValue(form, name)
{
    if (!form[name]) {
        return null;
    }

    for (var i = 0; i < form[name].length; i++) {
        if (form[name][i].checked) {
            return form[name][i].value;
        }
    }

    return null;
}

function setFormRadioValue(form, name, value)
{
    if (!form[name]) {
        return;
    }

    form[name][0].checked = true;
    for (var i = 0; i < form[name].length; i++) {
        if (form[name][i].value == value) {
            form[name][i].checked = true;
            break;
        }
    }
}

function getFormCheckboxChecked(form, name)
{
    if (!form[name]) {
        return null;
    }

    return form[name].checked;
}

function setFormCheckboxChecked(form, name, check)
{
    if (!form[name]) {
        return;
    }

    form[name].checked = check;
}

function checkDirectory(obj, id)
{
    var block = document.getElementById(id);
    var inputs = block.getElementsByTagName('input');

    var check = !inputs[0].checked;

    for (var i = 0; i < inputs.length; i++) {
        if (inputs[i].name == 'encid') {
            inputs[i].checked = check;
        }
    }

    obj.blur();

    return false;
}

function changeSearch(id, form)
{
    var lingvo = document.getElementById('lingvo');
    var encyc = document.getElementById('encyc');

    if (id == 'lingvo') {
        document.getElementById('kbd_switch_on').style.display = (show_kbd) ? '' : 'none';
        document.getElementById('kbd_switch_on_title').style.display = (show_kbd) ? '' : 'none';
        document.getElementById('kbd_line').style.display = (show_kbd) ? '' : 'none';
        document.getElementById('kbd_switch_off').style.display = (show_kbd) ? 'none' : '';
        lingvo.style.display = '';
        encyc.style.display = 'none';
        is_lingvo = true;
        for (var i in langs) {
            var lang = langs[i];
            var rad = document.getElementById('title-' + lang);
            if (rad && rad.checked) {
                setAdvLang('block-' + lang, lang);
                break;
            }
        }
    } else {
        document.getElementById('kbd_switch_on').style.display = 'none';
        document.getElementById('kbd_switch_on_title').style.display = 'none';
        document.getElementById('kbd_switch_off').style.display = 'none';
        document.getElementById('kbd_line').style.display = 'none';
        lingvo.style.display = 'none';
        encyc.style.display = '';
        is_lingvo = false;
    }
}

function disableAdvLingvo(b)
{
    document.forms['search'].elements['mord'].disabled = b;
    document.forms['search'].elements['dist'].disabled = b;
    document.getElementById('distance_label1').disabled = b;
    document.getElementById('distance_label2').disabled = b;
    document.getElementById('order_label').disabled = b;
}

function setAdvLang(id, lang)
{
    var i, block, inputs;

    block = document.getElementById('languages');
    inputs = block.getElementsByTagName('input');

    for (i = 0; i < inputs.length; i++) {
        inputs[i].disabled = true;
    }

    inputs = block.getElementsByTagName('ul');

    for (i = 0; i < inputs.length; i++) {
        inputs[i].style.display = 'none';
    }

    block = document.getElementById(id);
    block.style.display = '';

    inputs = block.getElementsByTagName('input');

    for (i = 0; i < inputs.length; i++) {
        inputs[i].disabled = false;
    }

    lingvo_lang = lang;
}

function checkDicts(obj)
{
    var i, block, inputs, check;

    block = document.getElementById('block-' + lingvo_lang);
    inputs = block.getElementsByTagName('input');

    if (inputs) {
        check = !inputs[0].checked;
        for (i = 0; i < inputs.length; i++) {
            inputs[i].checked = check;
        }
    }

    obj.blur();
    return false;
}

function lang2langid(lang)
{
    switch (lang) {
        default:
        case 'en': return 0;
        case 'de': return 1;
        case 'fr': return 2;
        case 'it': return 3;
        case 'es': return 4;
    }
}

function get_adv_inputs(lang)
{
    var block_lang = document.getElementById('block-' + lang);
    var dict_inputs = block_lang.getElementsByTagName('input');
    delete block_lang;

    var block_adv = document.getElementById('lang-adv');
    var adv_inputs = block_adv.getElementsByTagName('input');
    delete block_adv;

    var i, inputs = [];
    for (i = 0; i < dict_inputs.length; i++) {
        inputs[inputs.length] = dict_inputs[i];
    }
    delete dict_inputs;

    for (i = 0; i < adv_inputs.length; i++) {
        inputs[inputs.length] = adv_inputs[i];
    }
    delete adv_inputs;

    return inputs;
}

// AdvSearch Object
function AdvSearch(langs, sites)
{
    this.langs = langs;
    this.sites = sites;
    this.block = ['lingvo', 'encyc'];
}

function AdvSearch_Save(form)
{
    var i, j, block, inputs, input, name, length, id;

    // disabled all elements in hidden block
    for (i = 0; i < this.block.length; i++) {
        id = this.block[i];
        block = document.getElementById(id);
        if (block.style.display == 'none') {
            inputs = block.getElementsByTagName('input');
            for (j = 0; j < inputs.length; j++) {
                inputs[j].disabled = true;
            }
            break;
        }
    }

    for (i = 0; i < this.block.length; i++) {
        id = this.block[i];
        block = document.getElementById(id);
        if (block.style.display != 'none') {
            break;
        }
    }

    //form.action = this.sites[id] + 'search.xml';

    // save encyc
    var encyc_arr = [];
    var encyc_hash = {};
    var encyc_str = '';

    block = document.getElementById('encyc');
    inputs = block.getElementsByTagName('input');

    // create hash
    for (i = 0; i < inputs.length; i++) {
        input = inputs[i];
        if (input.checked) {
            name = input.name;
            if (typeof(encyc_hash[name]) == UNDEF) {
                encyc_hash[name] = [];
            }
            encyc_hash[name][encyc_hash[name].length] = inputs[i].value;
        }
    }

    // convert hash to array
    for (i in encyc_hash) {
        encyc_arr[encyc_arr.length] = i + ':' + encyc_hash[i].join(',');
    }
    delete encyc_hash;

    encyc_str = encyc_arr.join('|');
    delete encyc_arr;

    setCookie(cookie_encyc_dicts, encyc_str, cookie_timeout);
    delete encyc_str;

    // save lingvo
    var save_arr = [];
    var new_data = [];

    for (j = 0; j < this.langs.length; j++) {
        var lang = this.langs[j];
        var langid = lang2langid(lang);
        var dmask = 0, dsmask = 1;
        var smask = 0, ssmask = 1;

        inputs = get_adv_inputs(lang);
        for (i = 0; i < inputs.length; i++) {
            input = inputs[i];
            id = input.id;

            if (id == '') continue;

            // text field
            if (input.type == 'text') {
                new_data[new_data.length] = parseInt(input.value);
                continue;
            }

            // checked fields
            if ((input.type == 'radio' || input.type == 'checkbox')) {
                if (id.indexOf('d') == 0) {
                    dmask |= (input.checked ? dsmask : 0);
                    dsmask = dsmask << 1;
                } else {
                    smask |= (input.checked ? ssmask : 0);
                    ssmask = ssmask << 1;
                }
                continue;
            }
        }

        var sdata = '' + smask;
        if (new_data.length != 0) {
            sdata += '+' + new_data.join('+');
        }
        save_arr[0] = sdata;
        save_arr[langid + 1] = dmask;
    }

    var save_str = save_arr.join('-');
    setCookie(cookie_lingvo_dicts, save_str, cookie_timeout);
}

function AdvSearch_Load(form)
{
    var i, j, k, block, inputs, input, id, values, name, arr;

    var encyc_str = getCookie(cookie_encyc_dicts);
    if (encyc_str != null) {
        var encyc_hash = {};
        var encyc_arr = encyc_str.split('|');
        for (i in encyc_arr) {
            var sp = encyc_arr[i].split(':');
            if (sp[0] && sp[1]) {
                encyc_hash[sp[0]] = sp[1].split(',');
            }
        }

        block = document.getElementById('encyc');
        inputs = block.getElementsByTagName('input');

        for (i = 0; i < inputs.length; i++) {
            input = inputs[i];
            name = input.name;
            arr = encyc_hash[name];
            input.checked = (typeof(arr) != UNDEF && contains(arr, input.value));
        }
    }

    // load lingvo
    var save_str = getCookie(cookie_lingvo_dicts);
    if (save_str == null) {
        return;
    }

    var save_arr = save_str.split('-');

    for (j = 0; j < this.langs.length; j++) {
        var lang = this.langs[j];
        var langid = lang2langid(lang);

        var sdata = save_arr[0].split('+');
        var dstr  = save_arr[langid + 1];
        var dmask = parseInt(dstr);
        var sstr  = ((sdata.length > 0) ? sdata[0] : '');
        var smask = parseInt(sstr);

        inputs = get_adv_inputs(lang);

        k = 1;
        for (i = 0; i < inputs.length; i++) {
            input = inputs[i];
            id = input.id;

            if (id == '') {
                continue;
            }

            // text field
            if (input.type == 'text' && k < sdata.length) {
                input.value = sdata[k++];
                continue;
            }

            // checked fields
            if ((input.type == 'radio' || input.type == 'checkbox')) {
                var checked;
                if (id.indexOf('d') == 0) {
                    if (dstr == '') continue;
                    checked = dmask & 1;
                    dmask = dmask >> 1;
                } else {
                    if (sstr == '') continue;
                    checked = smask & 1;
                    smask = smask >> 1;
                }
                input.checked = (checked == 1 ? true : false);
                if (checked == 1 && input.onclick) {
                    input.onclick(0);
                }
                continue;
            }
        }
    }
}

// prototypes
AdvSearch.prototype.save	= AdvSearch_Save;
AdvSearch.prototype.load	= AdvSearch_Load;


// End of AdvSearch Object

// LingvoTune Object
function LingvoTune(form)
{
    this.form = form || document.forms['tune'];

    this.user_prefs = 0;
    this.radios = {lang:16, tra:2, fun:4};
    this.checks = {cust_sel:2, cust_del:2, no_focus:64, dbg:128, nsr:256, aft:4096};
}

LingvoTune.prototype = {
    save: function(){
        var i, j, val;
        j = 0;
        var arr = new Array();
        var user_prefs = 0;
        for (i in this.radios) {
            val = getFormRadioValue(this.form, i);
            if (val) {
                arr[j] = val;
                j++;
                user_prefs += parseInt(val) << this.radios[i];
            }

        }
        arr[j] = 0;
        for (i in this.checks) {
            if (getFormCheckboxChecked(this.form, i)) {
                arr[j] = this.checks[i];
                user_prefs += this.checks[i];
            }
        }
        j++;
        arr[j] = user_prefs;
        setCookieNew(arr, 31);
    },
    load: function(params){
        var i, val;

        this.user_prefs = getCookie(cookie_lingvo_pref);
        if (this.user_prefs == null) {
            return;
        }

        this.user_prefs = parseInt(this.user_prefs);

        for (i in this.radios) {
            if (params && params[i]) {
                setFormRadioValue(this.form, i, params[i]);
            } else {
                setFormRadioValue(this.form, i, (this.user_prefs >> this.radios[i]) % 16);
            }
        }

        for (i in this.checks) {
            setFormCheckboxChecked(this.form, i, (this.user_prefs & this.checks[i]));
        }
    },
    def: function(){
        setCookie(cookie_lingvo_pref, '0');
        this.load();
    }
};

// End of LingvoTune Object


function check_focus(kbd, no_init)
{
    var form = document.forms['search'];
    if (form && form.text) {
        var url = window.location.toString();
        var offs = url.indexOf("#");
        if (form.text.value == '' && offs > 0)
        {
            if (decodeURIComponent) {
                form.text.value = decodeURIComponent(url.substring(offs + 1, url.length));
                form.init_text.value = form.text.value;
            }
        }
        else if (no_init && offs == -1)
        {
            if (form.init_text.value != '') {
                form.text.value = form.init_text.value;
            }
        }

        form.text.focus();

        
//        if(typeof(cookie_pref) == 'undefined' || cookie_pref[2] != 2) {
            form.text.select();
//        }
    }
}

function check_link(obj)
{
    var form = document.forms['search'];
    if (form.text.value.length) {
        window.location.href = obj.href + "?text=" + form.text.value;
        return false;
    }
    return true;
}
function disabled_lingvo(obj, lingvo)
{
    var disab = lingvo ? !obj.checked : obj.checked;
    var in_dict = document.getElementById('in_this_dict');
    if (in_dict) {
        in_dict.disabled = disab;
    }

    var form = obj.form;
    if (form.lang && form.search_type) {
        form.lang.disabled = disab;
        form.search_type.disabled = disab;
    }
    /*
    if (in_dict) {
        in_dict.disabled = (obj.checked) ? true : false;
    }*/
}

function check_in_dict(obj, lingvo)
{
    disabled_lingvo(obj, lingvo);
    checked_translate = true;
    // в куки сохраняем измененное вручную состояние чекбокса 'перевод'
    var checked = (obj.checked) ? 1 : 0;
    setCookie('ya_chbTranslate', checked, cookie_timeout);
}

function set_lingvo()
{
    if (!checked_translate) {
        var form = document.forms['search'];
        var text = form.text.value;

        if (text.length) {
            // если чекбокс 'перевод' был выбран вручную, то его состояние не меняем
            if (agt.indexOf('safari') == -1 && getCookie('ya_chbTranslate') == 0) {
                // Если цифры в тексте, то не меняем чекбокс
                if(!/[0-9]/.test(text)) {
                    form.st_translate.checked = !text.match(/[\u0410-\u044F]/);
                }
            }
        } else {
            form.st_translate.checked = false;
        }

        disabled_lingvo(form.st_translate, false);

        setTimeout('set_lingvo()', 200);
    }
    typing_start = true;
}

function search_tabs()
{
    var i, found, obj, search_url, host, engine;
    var search_form = document.forms['search'];
    var text = search_form.text.value;
    var init_text = search_form.init_text.value;

    for (i in search_engines) {
        obj = document.getElementById('tab_' + i);
        if (obj != null) {
            engine = search_engines[i];
            found = engine[0] == '1';
            search_url = engine[1];
            host = engine[2];
            if (text != '') {
                // поскольку encodeURIComponent может отсутствовать в старых браузерах,
                // делаем проверку
                if (encodeURIComponent) {
                    obj.href = search_url + encodeURIComponent(text);
                }
                // для тех табиков, где поисковый запрос ничего не нашел
                // (для таких табиков в xsl выставляется соответствующий class)
                if (!found) {
                    // если текст в строке поиска изменен, то снимаем класс,
                    // иначе возвращаем класс на место
                    obj.className = (init_text != text || init_text == '') ? '' : 'n'; // важно: класс здесь и в xsl должен быть одинаковым!
                }
            } else {
                obj.href = host;
            }
        }
    }

    setTimeout('search_tabs()', 200);
}

function handle_search_input()
{
    if (!typing_start) {
        setTimeout('set_lingvo()', 200);
    }
}

function submit_search(frm, slovari_site, lingvo_site)
{
    if (frm.st_translate && frm.st_translate.checked) {
        frm.action = lingvo_site + 'search.xml';
        frm.search_type && (frm.search_type.disabled = false);
        frm.lang && (frm.lang.disabled = false);
    } else {
        frm.action = slovari_site + 'search.xml';
        frm.search_type && (frm.search_type.disabled = true);
        frm.lang && (frm.lang.disabled = true);
    }
    if (typeof(rememberStateOfSwitch) != UNDEF) {
        var st_translate = (frm.st_translate.checked) ? '&st_translate=' + frm.st_translate.value : '';
        var retpath = frm.action + '?text=' + encodeURIComponent(frm.text.value) + st_translate;
        frm.retpath.value = retpath;
        frm.retpath.disabled = false;
        frm.action = '/save_switch_state.xml';

    }
    return true;
}
function r(a, w)
{
    if (w == 'enc' || w == 'encyc') w = 'stred/pid=20/cid=7';

    var img = new Image(1, 1);
    img.src = 'http://clck.yandex.ru/click/dtype=' + w + '/*' + a.href;
}
function check_href(obj)
{
    obj.href = '/advanced.xml?text=' + document.search.text.value;
    if(typeof(active_lang) == 'undefined') return true;
    var l = get_enc_name(active_lang);
    if (def_lang != 'index.xml'){
        if(active_lang == 0 && def_lang != 'en')
        {
            l = def_lang;
        }
    }
    obj.href += '&lang=' + l;
    return false;
}
function get_enc_name(id)
{
    var res;
    switch (id) {
        case 0:
            res = 'en';
            break
        case 1:
            res = 'de';
            break
        case 2:
            res = 'fr';
            break
        case 3:
            res = 'it';
            break
        case 4:
            res = 'es';
            break
        default:
            res = 'en';
            break
    }
    return res;
}

function check_dict(obj,str)
{
    var arr = str.split(',');
    for(var i in arr) {
        eval("document.forms['search']." + arr[i] + ".disabled = (obj.checked) ? false : true");
    }
}

// do prev/next
function doPrevNext()
{
    var linkPrev = document.getElementById('prev');
    if (linkPrev) {
        function goPrev(e)
        {
            if (e.target.tagName.toLowerCase() == 'input') {
                return;
            }
            if ((e.keyCode == 37) && (e.ctrlKey)) {
                window.location.href = linkPrev.href;
            }
        }
        new AEventListener('keyup', goPrev, document, true);
    }

    var linkNext = document.getElementById('next');
    if (linkNext) {
        function goNext(e)
        {
            if (e.target.tagName.toLowerCase() == 'input') {
                return;
            }
            if ((e.keyCode == 39) && (e.ctrlKey)) {
                window.location.href = linkNext.href;
            }
        }
        new AEventListener('keyup', goNext, document, true);
    }

    var inputText = document.getElementById('text');
    if (inputText) {
        function goToInput(e)
        {
            if ((e.keyCode == 38) && (e.ctrlKey)) {
                check_focus(0, false);
            }
        }
        new AEventListener('keyup', goToInput, document, true);
    }
}
